"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _multipleChoiceList = _interopRequireDefault(require("@data-driven-forms/common/multiple-choice-list"));

var _controls = require("@blueprintjs/core/lib/cjs/components/forms/controls.js");

var _formGroup = require("@blueprintjs/core/lib/cjs/components/forms/formGroup.js");

var _intent = require("@blueprintjs/core/lib/cjs/common/intent.js");

var _formGroup2 = _interopRequireDefault(require("../form-group/form-group"));

var _propsCatcher = _interopRequireDefault(require("../props-catcher/props-catcher"));

var _blueprintContext = _interopRequireDefault(require("../blueprint-context/blueprint-context"));

var SingleCheckbox = function SingleCheckbox(_ref) {
  var input = _ref.input,
      isDisabled = _ref.isDisabled,
      disabled = _ref.disabled,
      label = _ref.label,
      providerRequired = _ref.providerRequired,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["input", "isDisabled", "disabled", "label", "providerRequired"]);
  return /*#__PURE__*/_react["default"].createElement(_controls.Checkbox, (0, _extends2["default"])({
    label: label
  }, (0, _propsCatcher["default"])(props), props.isRequired && {
    label: /*#__PURE__*/_react["default"].createElement("span", null, label, " ", providerRequired)
  }, {
    disabled: disabled || isDisabled
  }, input));
};

SingleCheckbox.propTypes = {
  input: _propTypes["default"].object,
  isDisabled: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  providerRequired: _propTypes["default"].node,
  disabled: _propTypes["default"].bool
};

var Wrapper = function Wrapper(_ref2) {
  var children = _ref2.children,
      isRequired = _ref2.isRequired,
      showError = _ref2.showError,
      error = _ref2.error,
      validateOnMount = _ref2.validateOnMount,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["children", "isRequired", "showError", "error", "validateOnMount"]);

  var _useContext = (0, _react.useContext)(_blueprintContext["default"]),
      required = _useContext.required;

  return /*#__PURE__*/_react["default"].createElement(_formGroup.FormGroup, (0, _extends2["default"])({}, props, isRequired && {
    labelInfo: required
  }, error && (showError || validateOnMount) && {
    helperText: error,
    intent: _intent.Intent.DANGER
  }), children);
};

Wrapper.propTypes = {
  children: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  showError: _propTypes["default"].bool,
  error: _propTypes["default"].string,
  validateOnMount: _propTypes["default"].bool
};

var WrapperCheckbox = function WrapperCheckbox(props) {
  return props.options ? /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({}, props, {
    Wrapper: Wrapper,
    Checkbox: SingleCheckbox
  })) : /*#__PURE__*/_react["default"].createElement(_formGroup2["default"], (0, _extends2["default"])({}, props, {
    hideLabel: true,
    Component: SingleCheckbox
  }));
};

WrapperCheckbox.propTypes = {
  options: _propTypes["default"].array
};
var _default = WrapperCheckbox;
exports["default"] = _default;