"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.itemPredicate = exports.tagRenderer = exports.multiOnChange = exports.itemRenderer = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _formGroup = _interopRequireDefault(require("../form-group/form-group"));

var _select = require("@blueprintjs/select");

var _propsCatcher = _interopRequireDefault(require("../props-catcher/props-catcher"));

var _menuItem = require("@blueprintjs/core/lib/cjs/components/menu/menuItem.js");

var _buttons = require("@blueprintjs/core/lib/cjs/components/button/buttons.js");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _itemRenderer = function itemRenderer(item, _ref, value) {
  var handleClick = _ref.handleClick;
  return /*#__PURE__*/_react["default"].createElement(_menuItem.MenuItem, (0, _extends2["default"])({
    key: item.value
  }, item, !item.text && {
    label: '',
    text: item.label
  }, {
    onClick: handleClick,
    icon: item.value === value || Array.isArray(value) && value.includes(item.value) ? 'tick' : 'blank'
  }));
};

exports.itemRenderer = _itemRenderer;

var multiOnChange = function multiOnChange(item, input) {
  return input.value && !input.value.includes(item.value) ? input.onChange([].concat((0, _toConsumableArray2["default"])(input.value), [item.value])) : input.onChange(input.value ? input.value.filter(function (v) {
    return v !== item.value;
  }) : [item.value]);
};

exports.multiOnChange = multiOnChange;

var _tagRenderer = function tagRenderer(item, options) {
  var option = options.find(function (_ref2) {
    var value = _ref2.value;
    return value === item;
  });

  if (option) {
    return option.text || option.label;
  }
};

exports.tagRenderer = _tagRenderer;

var itemPredicate = function itemPredicate(query, item) {
  if (!query) {
    return item;
  }

  if (item.label.toLowerCase().includes(query.toLowerCase())) {
    return item;
  }
};

exports.itemPredicate = itemPredicate;

var Select = function Select(_ref3) {
  var input = _ref3.input,
      options = _ref3.options,
      placeholder = _ref3.placeholder,
      isSearchable = _ref3.isSearchable,
      noOptionsMessage = _ref3.noOptionsMessage,
      isMulti = _ref3.isMulti,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["input", "options", "placeholder", "isSearchable", "noOptionsMessage", "isMulti"]);
  var Component = isMulti ? _select.MultiSelect : _select.Select;
  var selectedOption = options.find(function (_ref4) {
    var value = _ref4.value;
    return value === input.value;
  });
  return /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({
    itemPredicate: itemPredicate,
    onItemSelect: function onItemSelect(_ref5) {
      var value = _ref5.value;
      return input.onChange(value);
    },
    noResults: /*#__PURE__*/_react["default"].createElement(_menuItem.MenuItem, {
      disabled: true,
      text: noOptionsMessage
    }),
    items: options,
    itemRenderer: function itemRenderer(item, args) {
      return _itemRenderer(item, args, input.value);
    },
    filterable: isSearchable
  }, (0, _propsCatcher["default"])(props), isMulti && {
    selectedItems: input.value || [],
    tagRenderer: function tagRenderer(item) {
      return _tagRenderer(item, options);
    },
    onItemSelect: function onItemSelect(item) {
      return multiOnChange(item, input);
    },
    tagInputProps: _objectSpread(_objectSpread({}, props.tagInputProps), {}, {
      onRemove: function onRemove(item) {
        return multiOnChange({
          value: item
        }, input);
      }
    })
  }, input), !isMulti && /*#__PURE__*/_react["default"].createElement(_buttons.Button, {
    text: selectedOption ? selectedOption.label : placeholder,
    rightIcon: "caret-down",
    disabled: props.disabled
  }));
};

Select.propTypes = {
  input: _propTypes["default"].object,
  options: _propTypes["default"].array,
  placeholder: _propTypes["default"].node,
  isSearchable: _propTypes["default"].bool,
  noOptionsMessage: _propTypes["default"].node,
  tagInputProps: _propTypes["default"].object,
  isMulti: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool
};
Select.defaultProps = {
  noOptionsMessage: 'No options found',
  placeholder: 'Please select',
  isSearchable: false
};

var WrapperSelect = function WrapperSelect(props) {
  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], (0, _extends2["default"])({}, props, {
    Component: Select
  }));
};

var _default = WrapperSelect;
exports["default"] = _default;