"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _selectNext = _interopRequireDefault(require("@data-driven-forms/common/wizard/select-next"));

var _clsx = _interopRequireDefault(require("clsx"));

var _buttons = require("@blueprintjs/core/lib/cjs/components/button/buttons.js");

var _intent = require("@blueprintjs/core/lib/cjs/common/intent.js");

require("./step-buttons.scss");

var NextButton = function NextButton(_ref) {
  var nextStep = _ref.nextStep,
      handleNext = _ref.handleNext,
      buttonLabels = _ref.buttonLabels,
      getState = _ref.getState,
      handleSubmit = _ref.handleSubmit,
      isDisabled = _ref.isDisabled,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["nextStep", "handleNext", "buttonLabels", "getState", "handleSubmit", "isDisabled"]);
  return /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    disabled: isDisabled,
    onClick: function onClick() {
      return nextStep ? handleNext((0, _selectNext["default"])(nextStep, getState)) : handleSubmit();
    },
    rightIcon: nextStep ? 'arrow-right' : 'arrow-up',
    intent: _intent.Intent.SUCCESS
  }, props), nextStep ? buttonLabels.next : buttonLabels.submit);
};

NextButton.propTypes = {
  handleNext: _propTypes["default"].func,
  formOptions: _propTypes["default"].shape({
    onCancel: _propTypes["default"].func,
    renderForm: _propTypes["default"].func,
    getState: _propTypes["default"].func
  }),
  buttonLabels: _propTypes["default"].object,
  nextStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func, _propTypes["default"].object]),
  getState: _propTypes["default"].func,
  handleSubmit: _propTypes["default"].func,
  isDisabled: _propTypes["default"].bool
};

var StepButtons = function StepButtons(_ref2) {
  var handleNext = _ref2.handleNext,
      currentStep = _ref2.currentStep,
      formOptions = _ref2.formOptions,
      activeStepIndex = _ref2.activeStepIndex,
      buttonLabels = _ref2.buttonLabels,
      handlePrev = _ref2.handlePrev,
      isNextDisabled = _ref2.isNextDisabled,
      ButtonToolbarProps = _ref2.ButtonToolbarProps,
      DirectionButtonProps = _ref2.DirectionButtonProps,
      CancelButtonProps = _ref2.CancelButtonProps,
      BackButtonProps = _ref2.BackButtonProps,
      NextButtonProps = _ref2.NextButtonProps,
      SubmitButtonProps = _ref2.SubmitButtonProps;
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, ButtonToolbarProps, {
    className: (0, _clsx["default"])('ddorg__blueprint_mapper--wizard-button-group', ButtonToolbarProps && ButtonToolbarProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    onClick: formOptions.onCancel,
    minimal: true
  }, CancelButtonProps), buttonLabels.cancel), /*#__PURE__*/_react["default"].createElement("div", DirectionButtonProps, /*#__PURE__*/_react["default"].createElement(_buttons.Button, (0, _extends2["default"])({
    onClick: handlePrev,
    disabled: activeStepIndex === 0
  }, BackButtonProps), buttonLabels.back), /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({
    getState: formOptions.getState,
    nextStep: currentStep.nextStep,
    buttonLabels: buttonLabels,
    handleNext: handleNext,
    isDisabled: !formOptions.valid || isNextDisabled,
    handleSubmit: formOptions.handleSubmit
  }, currentStep.nextStep ? NextButtonProps : SubmitButtonProps))));
};

StepButtons.propTypes = {
  currentStep: _propTypes["default"].object,
  handlePrev: _propTypes["default"].func,
  handleNext: _propTypes["default"].func,
  formOptions: _propTypes["default"].shape({
    onCancel: _propTypes["default"].func,
    renderForm: _propTypes["default"].func,
    getState: _propTypes["default"].func,
    handleSubmit: _propTypes["default"].func,
    valid: _propTypes["default"].bool
  }),
  activeStepIndex: _propTypes["default"].number,
  buttonLabels: _propTypes["default"].object,
  isNextDisabled: _propTypes["default"].bool,
  ButtonToolbarProps: _propTypes["default"].object,
  DirectionButtonProps: _propTypes["default"].object,
  CancelButtonProps: _propTypes["default"].object,
  BackButtonProps: _propTypes["default"].object,
  NextButtonProps: _propTypes["default"].object,
  SubmitButtonProps: _propTypes["default"].object
};
var _default = StepButtons;
exports["default"] = _default;